package com.storlead.framework.common.util;

import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONObject;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/**
 * @program: storlead-saas-platform
 * @description:
 * @author: chenkq
 * @create: 2026-05-14 15:17
 */
public class HttpUtil {

    /**
     * 发送GET请求并返回响应内容
     * @param url
     * @param body 请求体
     * @param headers 请求头
     * @param timeout 超时时间
     * @return
     * @throws IOException
     */
    public static String get(String url, Map<String, String> body, Map<String, String> headers, int timeout) throws IOException {
        Map<String, String> header = new HashMap<>();
        header.put("Content-Type", "application/json;charset=UTF-8");
        header.put("Accept", "application/json;charset=UTF-8");
        if (Objects.nonNull(headers)) {
            header.putAll(headers);
        }
        HttpRequest httpRequest = HttpRequest.get(url).addHeaders(header).body(JSONObject.toJSONString(body));
        if (timeout > 0) {
            httpRequest.setConnectionTimeout(timeout);
            httpRequest.setReadTimeout(timeout);
        }
        String response = httpRequest.execute().body();
        return decodeUnicode(response);
    }

    /**
     * 发送POST请求并返回响应内容
     * @param url
     * @param body 请求体
     * @param headers 请求头
     * @param timeout 超时时间
     * @return
     * @throws IOException
     */
    public static String post(String url, Map<String, Object> body,Map<String, String> headers, int timeout) throws IOException {
        Map<String, String> header = new HashMap<>();
        header.put("Content-Type","application/json;charset=UTF-8");
        header.put("Accept","application/json;charset=UTF-8");
        if (Objects.nonNull(headers)) {
            header.putAll(headers);
        }
        HttpRequest httpRequest = HttpRequest.post(url).addHeaders(header).body(JSONObject.toJSONString(body));
        if (timeout > 0) {
            httpRequest.setConnectionTimeout(timeout);
            httpRequest.setReadTimeout(timeout);
        }
        String response = httpRequest.execute().body();

        return decodeUnicode(response);
    }

    /**
     * http 请求数据返回 json 中中文字符为 unicode 编码转汉字转码
     * @param theString
     * @return
     */
    public static String decodeUnicode(String theString) {
        char aChar;
        int len = theString.length();
        StringBuffer outBuffer = new StringBuffer(len);
        for (int x = 0; x < len;) {
            aChar = theString.charAt(x++);
            if (aChar == '\\') {
                aChar = theString.charAt(x++);
                if (aChar == 'u') {
                    int value = 0;
                    for (int i = 0; i < 4; i++) {
                        aChar = theString.charAt(x++);
                        switch (aChar) {
                            case '0':
                            case '1':
                            case '2':
                            case '3':
                            case '4':
                            case '5':
                            case '6':
                            case '7':
                            case '8':
                            case '9':
                                value = (value << 4) + aChar - '0';
                                break;
                            case 'a':
                            case 'b':
                            case 'c':
                            case 'd':
                            case 'e':
                            case 'f':
                                value = (value << 4) + 10 + aChar - 'a';
                                break;
                            case 'A':
                            case 'B':
                            case 'C':
                            case 'D':
                            case 'E':
                            case 'F':
                                value = (value << 4) + 10 + aChar - 'A';
                                break;
                            default:
                                throw new IllegalArgumentException(
                                        "Malformed   \\uxxxx   encoding.");
                        }

                    }
                    outBuffer.append((char) value);
                } else {
                    if (aChar == 't')
                        aChar = '\t';
                    else if (aChar == 'r')
                        aChar = '\r';
                    else if (aChar == 'n')
                        aChar = '\n';
                    else if (aChar == 'f')
                        aChar = '\f';
                    outBuffer.append(aChar);
                }
            } else {
                outBuffer.append(aChar);
            }
        }
        return outBuffer.toString();
    }

    public static void main(String[] args) {
//        try {
//            Map<String, Object> parameters = new HashMap<>();
//            parameters.put("activationCode", "activationCode");
//            String response = HttpUtil.sendPost("http://localhost:10010/api/tenant/license/getLicenseCode", parameters,5000);
//            log.error("response = "+response);
//        }catch (Exception e) {
//            log.error("error = ",e);
//        }
    }
}
